import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:calculus/config/default_activity_settings.dart';

class ActivitySettings {
  final String level;

  ActivitySettings({
    required this.level,
  });

  // Getters to convert String to int
  int get levelValue => int.parse(level);

  static String getLevelValueFromUnsafe(String level) {
    if (DefaultActivitySettings.allowedLevelValues.contains(level)) {
      return level;
    }

    return DefaultActivitySettings.defaultLevelValue;
  }

  factory ActivitySettings.createDefault() {
    return ActivitySettings(
      level: DefaultActivitySettings.defaultLevelValue,
    );
  }

  void dump() {
    printlog('$ActivitySettings:');
    printlog('  ${DefaultActivitySettings.parameterCodeLevel}: $level');
    printlog('');
  }

  @override
  String toString() {
    return '$ActivitySettings(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      DefaultActivitySettings.parameterCodeLevel: level,
    };
  }
}
